// A simplest example of using the Fisica library.
// Create a single object (a circle), with an initial
// upward velocity vector, and let it fall.  Fisica
// automatically assumes you want mild gravity, and
// doesn't constrain the object to lie within the bounds
// of the sketch.  Bye, circle.

// Yes, I want to use Fisica
import fisica.*;

// Create a master object to maintain the simulation.
FWorld world;

void setup()
{
  size(400, 400);

  // Initialize the physics engine (as always, we need
  // to tell Fisica about ourselves, via the use of "this").
  Fisica.init(this);

  // Create an actual simulatilon object.
  world = new FWorld();
 
  // Create a circle and give it some initial position
  // and velocity.  Note that Fisica's units are quite
  // different from the ones we've been using (velocity
  // is clearly not pixels per frame; maybe pixels per
  // second?)
  FBody circle = new FCircle( 50 );
  circle.setPosition( width/2, 100 );
  circle.setVelocity( 0, -200 );

  // Don't forget to actually put this body into the
  // simulation!
  world.add( circle );
}

void draw()
{
  // Run the physical simulation for
  // one step
  world.step();
  
 // Draw the world
  background(255);
  world.draw();
}
