// A demonstration of the relationship between an undamped
// spring and a sine function.  Simulation means that we don't
// need to think about this explicitly!  You don't need to be
// able to implement this sketch, it's for classroom demonstration
// purposes.

float position = 200;
float speed = 0.0;

// The rest length of the spring,
// relative to the left edge of the
// sketch.
float rest_length = 100.0;
// Constant in Hooke's law
float stiffness = 0.003;

boolean draw_dot;

void setup()
{
  size( 800, 200 );
  background( 255 );

  draw_dot = false;
}

void draw()
{
  // Run the physical simulation for
  // one step
  speed = (speed - stiffness*(position-rest_length));
  position = position + speed;
  
  // Draw the world
  // background( 80 );
  copy( 51, 0, 750, 200, 56, 0, 750, 200 );

  noStroke();
  fill( 80 );
  rect( 0, 0, 50, 200 );
  fill( 255 );
  rect( 50, 0, 6, 200 );

  stroke( 0 );
  fill( 255 );
  ellipse( 25, position, 50, 50 );

  if ( draw_dot ) {
    noStroke();
    fill( #ff0000 );
    ellipse( 53, position, 6, 6 );
  }

}

void keyPressed()
{
  if( key == ' ' ) {
    draw_dot = !draw_dot;
  }
}
