// An undamped spring.  This spring will continue to oscillate
// back and forth forever, since it never loses energy.

float position = 800;
float speed = 0.0;

// The rest length of the spring,
// relative to the left edge of the
// sketch.
float rest_length = 400.0;
// Constant in Hooke's law
float stiffness = 0.003;

void setup()
{
  size( 800, 100 );
}

// I'll do this in a couple of steps, for clarity.
// Normally I might compress the simulation into fewer
// lines of code.
void step()
{
  // How far is the spring extended from its
  // rest length? This is a signed value, i.e.,
  // an arrow that always points away from 
  // the rest length.
  float disp = position - rest_length;
  // Accelerate towards rest length
  speed = speed - stiffness * disp;

  // Now update position
  position = position + speed;
}

void draw()
{
  // Run the physical simulation for
  // one step
  step();
  
  // Draw the world
  background( 80 );
  ellipse( position, 50, 50, 50 );
}
