import fisica.*;

FWorld world;

float[][] tangrams = {
  { 0, 0, 0.25, 0.25, 0.5, 0 },
  { 0.5, 0, 1, 0.5, 1, 0 },
  { 0.25, 0.25, 0.5, 0.5, 0.75, 0.25, 0.5, 0 },
  { 0.5, 0.5, 0.75, 0.75, 0.75, 0.25 },
  { 0.75, 0.25, 0.75, 0.75, 1.0, 1.0, 1.0, 0.5 },
  { 0, 0, 0, 1, 0.5, 0.5 },
  { 0.5, 0.5, 0, 1, 1, 1 } };
  
void setup()
{
    size( 600, 600 );
    
    Fisica.init( this );
    world = new FWorld();
    world.setEdges();
    world.setGravity( 0.0, 0.0 );
    world.setEdgesFriction( 1 );
    
    float cx = 0.5 * width;
    float cy = 0.5 * height;
    float sc = 0.5 * min( width, height );
    
    for( int idx = 0; idx < tangrams.length; ++idx ) {
      FPoly bod = new FPoly();
      bod.setNoStroke();
      bod.setFill( 40 );
      bod.setDensity( 100 );
      bod.setDamping( 5 );
      bod.setAngularDamping( 5 );
      for( int jdx = 0; jdx < tangrams[idx].length; jdx += 2 ) {
        bod.vertex( 
          cx - sc*(tangrams[idx][jdx]-0.5), 
          cy - sc*(tangrams[idx][jdx+1]-0.5) );
      }
      world.add( bod );
    }
}

void draw()
{
  background( 255 );
  world.step();
  world.draw();
}
