// A simple demonstration of the Third Law of
// motion.  Let an object accelerate towards the
// bottom of the sketch, and have it bounce off
// the bottom and head back upwards.

float position = 0;
float speed = 0;
float accel = 0.4;

void setup()
{
  size( 100, 600 );
}

void step()
{
  // Update speed using acceleration.
  speed = speed + accel;
  // Update position using speed.
  position = position + speed;
  
  // Wait: in its new position, did the object
  // fall beneath the bottom of the sketch?  If
  // so, snap it back to the bottom of the sketch
  // and set it to head back up towards the top
  // with its original speed.
  if( position+25 > height ) {
    position = height - 25;
    speed = -speed;
  }
  
  // This simulation is too simple: even though 
  // the object should return to its original height
  // after a bounce, it still loses a bit of energy
  // each time it hits the floor.  Why?  The reason
  // is quite tricky.
}

void draw()
{
  // Run the physical simulation for
  // one step
  step();
  
  // Draw the world
  background( 80 );
  ellipse( 50, position, 50, 50 );
}
